var tag = require("./strings");
var func = require('./func');
var Hand = require('./error_hand');
var path = require('path');
var MiraQuery = require('./query');

module.exports = function (_storage, _charSet) {
    var storage = _storage;
    var charSet = _charSet;  
    function OpenDB(STO, DB, TBL, CHR) {
        if (func.Check(STO)) {
            if (func.Check(path.join(STO, DB))) {
                var url = path.join(STO, DB, TBL + func.Setting.ext);
                if (func.Check(url)) {
                    return ["0", func.decrypt(func.ImportFile(url, CHR))];
                } else {
                    return Hand.Error("e0xje06", TBL);
                }
            } else {
                return Hand.Error("e0xje213", DB);
            }
        } else {
            return Hand.Error("e0xje13", STO);
        }
    }

    function Query(CMD, DB, PERM, callback) {
        try {
            PERM = typeof PERM !== 'undefined' ? PERM : { SELECT: true, ADD: true, UNIQUE: true, UPDATE: true, RENAME: true, DROP: true, DELETE: true, CREATE: true, LIST: true };
            CMD = typeof CMD !== 'undefined' ? CMD : "null";
            var _s = CMD.toLowerCase();
            var JqlString = _s.match(tag.TAG);
            var jqlStringIns = /[";']/g;
            switch (JqlString[0]) {
                case "unique":
                    //UNIQUE
                    if (PERM.UNIQUE) {
                        if (JqlString.indexOf("column") > -1 && JqlString.indexOf("table") > -1) {
                            var OutPut = func.BuildQuery(_s, tag.UNIQUE_COL);
                            var _DB = OpenDB(storage, DB, OutPut[2], charSet);
                            if (_DB[0] == 0) {
                                var _TBL = JSON.parse(_DB[1]);
                                MiraQuery.UNIQUE(_TBL, OutPut[1], function (data) {
                                    _DB = data;
                                });
                            }
                            return _DB;
                        }
                    } else {
                        return Hand.Error("e0xje14", "UNIQUE");
                    }
                    break;
                case "update":
                    if (PERM.UPDATE) {
                        //UPDATE
                        if (JqlString.indexOf("value") > -1 && JqlString.indexOf("find") > -1 && JqlString.indexOf("column") > -1) {
                            var OutPut = func.BuildQuery(_s, tag.UPDATE_ROW);
                            var _DB = OpenDB(storage, DB, OutPut[1], charSet);
                                temp_col = JSON.parse(OutPut[2]);
                                temp_val = JSON.parse(OutPut[3]);
                                temp_str = JSON.parse(OutPut[5]);
                                fileJQL = path.join(storage, DB, OutPut[1] + func.Setting.ext);
                                    if (_DB[0] == 0) {
                                        MiraQuery.UPDATE_TABLE(fileJQL, JSON.parse(_DB[1]) , temp_col, temp_val, temp_str, function (data) {
                                            _DB = data;
                                        });
                                    }
                            return _DB;
                        }
                    } else {
                        return Hand.Error("e0xje14", "UPDATE");
                    }
                    break;
                case "list":
                    if (PERM.LIST) {
                        //LIST
                        if (JqlString.indexOf("list") > -1 && JqlString.indexOf("table") > -1) {
                            var _RESULT;
                            var OutPut = func.BuildQuery(_s, tag.LIST_TABLE);
                            temp_dir = path.join(storage, OutPut[1]);
                            MiraQuery.LIST_TABLE(temp_dir, function (result, data) {
                                _RESULT = result;
                            });
                            return _RESULT;
                        }
                        if (JqlString.indexOf("list") > -1 && JqlString.indexOf("database") > -1) {
                            temp_dir = path.join(storage, "/");
                            var _RESULT;
                            MiraQuery.LIST_DATABSE(temp_dir, function (result, data) {
                                _RESULT = result;
                            });
                            return _RESULT;
                        }
                    } else {
                        return Hand.Error("e0xje14", "LIST");
                    }
                    break;
                case "drop":
                    if (PERM.DROP) {
                        //DROP TABLE
                        if (JqlString.indexOf("drop") > -1 && JqlString.indexOf("table") > -1) {
                            var _RESULT = null;
                            var OutPut = func.BuildQuery(_s, tag.DROP_TABLE);
                            temp_tbl = OutPut[1];
                            temp_dir = path.join(storage, DB);
                            MiraQuery.DROP_TABLE(temp_dir, temp_tbl, func.Setting.ext, function (result) {
                                _RESULT = result;
                            });
                            return _RESULT;
                        }
                        //DROP DB
                        if (JqlString.indexOf("drop") > -1 && JqlString.indexOf("database") > -1) {
                            var _RESULT = null;
                            var OutPut = func.BuildQuery(_s, tag.DROP_DATABASE);
                            temp_dir = path.join(storage, OutPut[1]);
                            temp_val = OutPut[1];
                            MiraQuery.DROP_DATABASE(temp_dir, temp_val, function (result) {
                                _RESULT = result;
                            });
                            return _RESULT;
                        }
                    } else {
                        return Hand.Error("e0xje14", "DROP");
                    }
                    break;
                case "create":
                    if (PERM.CREATE) {
                        //CREATE TABLE  
                        if (JqlString.indexOf("create") > -1 && JqlString.indexOf("table") > -1 && JqlString.indexOf("column") > -1 && JqlString.indexOf("value") > -1) {
                            var _RESULT;
                            var OutPut = func.BuildQuery(_s, tag.CREATE_TABLE);
                            temp_col = JSON.parse(OutPut[2]);
                            temp_val = JSON.parse(OutPut[4]);
                            temp_tbl = OutPut[1];
                            temp_dir = path.join(storage, DB);
                            MiraQuery.CREATE_TABLE(temp_dir, temp_tbl, temp_col, temp_val, function (result) {
                                _RESULT = result;
                            });
                            return _RESULT;
                        }
                        //CREATE DB  
                        if (JqlString.indexOf("create") > -1 && JqlString.indexOf("database") > -1) {
                            var OutPut = func.BuildQuery(_s, tag.CREATE_DATABASE);
                            var DB_NAME = path.join(storage, OutPut[1]);
                            var _RESULT;
                            MiraQuery.CREATE_DATABASE(DB_NAME, OutPut[1], function (err, data) {
                                if (err) {
                                    _RESULT = err;
                                } else {
                                    _RESULT = data;
                                }
                            });
                            return _RESULT;
                        }
                    } else {
                        return Hand.Error("e0xje14", "CREATE");
                    }
                    break;
                case "delete":
                    if (PERM.DELETE) {
                        //DELETE COLUMN
                        if (JqlString.indexOf("delete") > -1 && JqlString.indexOf("column") > -1 && JqlString.indexOf("table") > -1) {
                            var OutPut = func.BuildQuery(_s, tag.DELETE_COLUMN);
                            var _DB = OpenDB(storage, DB, OutPut[2], charSet);
                            var fileJQL = path.join(storage, DB, OutPut[2] + func.Setting.ext);
                            temp_col = JSON.parse(OutPut[1]);
                            if (_DB[0] == 0) {
                                    MiraQuery.DELETE_COLUMN(fileJQL, JSON.parse(_DB[1]) , temp_col, function (data) {
                                        _DB = data;
                                    });
                            }
                            return _DB;
                        }
                        //DELETE ROW
                        if (JqlString.indexOf("delete") > -1 && JqlString.indexOf("column") > -1 && JqlString.indexOf("row") > -1) {
                            var OutPut = func.BuildQuery(_s, tag.DELETE_ROW);
                            var _DB = OpenDB(storage, DB, OutPut[1], charSet);
                            var temp_val = JSON.parse(OutPut[4]);
                            var fileJQL = path.join(storage, DB, OutPut[1] + func.Setting.ext);
                            if (_DB[0] == 0) {
                                    return MiraQuery.DELETE_ROW(fileJQL, JSON.parse(_DB[1]) , OutPut[2], temp_val)
                            }
                        }
                        //DELETE ROW INDEX
                        if (JqlString.indexOf("delete") > -1 && JqlString.indexOf("index") > -1 && JqlString.indexOf("row") > -1) {
                            var OutPut = func.BuildQuery(_s, tag.DELETE_INDEX);
                            var _DB = OpenDB(storage, DB, OutPut[1], charSet);
                            var fileJQL = path.join(storage, DB, OutPut[1] + func.Setting.ext);
                            var temp_val = OutPut[2];
                            if (_DB[0] == 0) {
                                return MiraQuery.DELETE_ROW_INDEX(fileJQL, JSON.parse(_DB[1]), temp_val, OutPut[1] )
                            }
                        }
                    } else {
                        return Hand.Error("e0xje14", "DELETE");
                    }
                    break;
                case "rename":
                    if (PERM.RENAME) {
                        //RENAME COLUMN NAME
                        if (JqlString.indexOf("rename") > -1 && JqlString.indexOf("column") > -1 && JqlString.indexOf("table") > -1 && JqlString.indexOf("value") > -1) {
                            var OutPut = func.BuildQuery(_s, tag.RENAME_COLUMN);
                            var _DB = OpenDB(storage, DB, OutPut[2], charSet);
                            temp_old = JSON.parse(OutPut[1]);
                            temp_new = JSON.parse(OutPut[4]);
                            fileJQL = path.join(storage, DB, OutPut[2] + func.Setting.ext);
                                if (_DB[0] == 0) {
                                    MiraQuery.RENAME_COLUMN(fileJQL, JSON.parse(_DB[1]) , temp_old, temp_new, function (data) {
                                        _DB = data;
                                    });
                                }
                            return _DB;
                        }
                        //RENAME DATABASE NAME
                        if (JqlString.indexOf("rename") > -1 && JqlString.indexOf("database") > -1 && JqlString.indexOf("value") > -1) {
                            var OutPut = func.BuildQuery(_s, tag.RENAME_DATABASE);
                            var _result = null;
                            temp_old = JSON.parse(OutPut[1]);
                            temp_new = JSON.parse(OutPut[2]);
                            MiraQuery.RENAME_DATABASE(storage, DB, temp_old, temp_new, function (err, data) {
                                if (!err) {
                                    _result = data;
                                } else {
                                    _result = err;
                                }
                            });
                            return _result;
                        }
                        //RENAME TABLE NAME
                        if (JqlString.indexOf("rename") > -1 && JqlString.indexOf("table") > -1 && JqlString.indexOf("value") > -1) {
                            var OutPut = func.BuildQuery(_s, tag.RENAME_TABLE);
                            var _result = null;
                            temp_old = JSON.parse(OutPut[1]);
                            temp_new = JSON.parse(OutPut[2]);
                            MiraQuery.RENAME_TABLE(storage, DB, temp_old, temp_new, function (err, data) {
                                if (!err) {
                                    _result = data;
                                } else {
                                    _result = err;
                                }
                            });
                            return _result;
                        }
                    } else {
                        return Hand.Error("e0xje14", "RENAME");
                    }
                    break;
                case "add":
                    if (PERM.ADD) {
                        //ADD ROW
                        if (JqlString.indexOf("add") > -1 && JqlString.indexOf("column") > -1 && JqlString.indexOf("row") > -1) {
                            var OutPut = func.BuildQuery(_s, tag.ADD_ROW);
                            var _DB = OpenDB(storage, DB, OutPut[1], charSet);
                            if (_DB[0] == 0) {
                                var _TBL = JSON.parse(_DB[1]);
                                temp_val = JSON.parse(OutPut[4]);
                                temp_col = JSON.parse(OutPut[2]);
                                fileJQL = path.join(storage, DB, OutPut[1] + func.Setting.ext);
                                MiraQuery.ADD_ROW(fileJQL, _TBL, temp_col, temp_val, function (err, data) {
                                    if (err) {
                                        _DB = err;
                                    } else {
                                        _DB = data;
                                    }
                                });
                            }
                            return _DB;
                        }
                        //ADD COLUMN
                        if (JqlString.indexOf("add") > -1 && JqlString.indexOf("column") > -1 && JqlString.indexOf("table") > -1) {
                            var OutPut = func.BuildQuery(_s, tag.ADD_COLUMN);
                            var _DB = OpenDB(storage, DB, OutPut[2], charSet);
                            var file = path.join(storage, DB, OutPut[2] + func.Setting.ext);
                            var temp_col = JSON.parse(OutPut[1]);
                            if (_DB[0] == 0) {
                                var _TBL = JSON.parse(_DB[1]);
                                MiraQuery.ADD_COLUMN(file, _TBL, temp_col, function (result) {
                                    _DB = result;
                                });
                            }
                            return _DB;
                        }
                    } else {
                        return Hand.Error("e0xje14", "ADD");
                    }
                    break;
                case "select":
                    if (PERM.SELECT) {
                        //SELECT TABLE FIND LIKE
                        if (JqlString.indexOf("select") > -1 && JqlString.indexOf("table") > -1 && JqlString.indexOf("column") > -1 && JqlString.indexOf("find") > -1 && JqlString.indexOf("like") > -1) {
                            var OutPut = func.BuildQuery(_s, tag.SELECT_FIND_LIKE);
                            var _DB = OpenDB(storage, DB, OutPut[1], charSet);
                            var temp_val = JSON.parse(OutPut[3]);
                            var temp_col = JSON.parse(OutPut[2]);
                            if (_DB[0] == 0) {
                                var _TBL = JSON.parse(_DB[1]);
                                MiraQuery.SELECT_TABLE_FIND_LIKE(_TBL, temp_val, temp_col, function (data) {
                                    _DB = data;
                                });
                            }
                            return _DB;
                        }

                        //SELECT TABLE FIND
                        if (JqlString.indexOf("select") > -1 && JqlString.indexOf("table") > -1 && JqlString.indexOf("column") > -1 && JqlString.indexOf("find") > -1) {
                            var OutPut = func.BuildQuery(_s, tag.SELECT_FIND);
                            var _DB = OpenDB(storage, DB, OutPut[1], charSet);
                            var temp_val = JSON.parse(OutPut[4]);
                            var temp_col = JSON.parse(OutPut[2]);
                            if (_DB[0] == 0) {
                                var _TBL = JSON.parse(_DB[1]);
                                MiraQuery.SELECT_TABLE_FIND(_TBL, temp_val, temp_col, function (data) {
                                    _DB = data;
                                });
                            }
                            return _DB;
                        }

                        //SELECT TABLE COLUMN
                        if (JqlString.indexOf("select") > -1 && JqlString.indexOf("table") > -1 && JqlString.indexOf("column") > -1) {
                            var OutPut = func.BuildQuery(_s, tag.SELECT_COLUMN);
                            var _DB = OpenDB(storage, DB, OutPut[1], charSet);
                                if (_DB[0] == 0) {
                                        MiraQuery.SELECT_TABLE_COLUMN( JSON.parse(_DB[1]) , JSON.parse(OutPut[2]) , function (data) {
                                            _DB = data;
                                        });
                                }
                             return _DB;
                        }
                        //SELECT TABLE LIMIT
                        if (JqlString.indexOf("select") > -1 && JqlString.indexOf("table") > -1 && JqlString.indexOf("limit") > -1) {
                            var OutPut = func.BuildQuery(_s, tag.SELECT_LIMIT);
                            var _DB = OpenDB(storage, DB, OutPut[1], charSet);
                            var temp_col = JSON.parse(OutPut[2]);
                            if (_DB[0] == 0) {
                                var _TBL = JSON.parse(_DB[1]);
                                MiraQuery.SELECT_LIMIT(_TBL, temp_col, function (data) {
                                    _DB = data;
                                });
                            }
                            return _DB;
                        }
                        //SELECT TABLE COUNT
                        if (JqlString.indexOf("select") > -1 && JqlString.indexOf("table") > -1 && JqlString.indexOf("count") > -1) {
                            var OutPut = _s.replace(jqlStringIns, '').split(tag.SELECT_COUNT)[1];
                            var _DB = OpenDB(storage, DB, OutPut, charSet);
                            if (_DB[0] == 0) {
                                var _DB = JSON.parse(_DB[1]);
                            }
                            return [_DB.length];
                        }
                        //SELECT TABLE
                        if (JqlString.indexOf("select") > -1 && JqlString.indexOf("table") > -1) {
                            var OutPut = _s.replace(jqlStringIns, '').split(tag.SELECT_TABLE)[1];
                            var _DB = OpenDB(storage, DB, OutPut, charSet);
                            if (_DB[0] == 0) {
                                var _TBL = JSON.parse(_DB[1]);
                                MiraQuery.SELECT_TABLE(_TBL, function (data) {
                                    _DB = data;
                                });
                            }
                            return _DB;
                        }
                    } else {
                        return Hand.Error("e0xje14", "SELECT");
                    }
                    break;
                default:
                    return Hand.Error("e0xje02", JqlString[0]);
                    break;
            }
        } catch (err) {
            return Hand.Error("e0xje01", "null");
        }
    }
    this.Query = function (CMD, DB, PERM, callback) {
        if (callback) {
            callback(Query(CMD, DB, PERM));
        } else {
            return Query(CMD, DB, PERM);
        }
    }
} 